/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  hra.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "PiskII.h"
#include "Hra.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// win thread pro premysleni
UINT t_Tahni(LPVOID hra);
bool t_kill = false;
bool t_hotovo = false;
bool t_running = false;


//******************************************************************************
// mix - vetsinou grafika
//******************************************************************************
CHra::CHra()
{
	m_lpDDAll.m_lpDDS = DDLoadBitmap(screen.m_lpDD,"all.bmp",0,0,FALSE);
	if (m_lpDDAll.m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	
	m_lpDDHra.m_lpDDS = DDLoadBitmap(screen.m_lpDD,"hra.bmp",0,0,FALSE);
	if (m_lpDDHra.m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

//	m_lpDDHra.SetColorKey(RGB(255,0,255));
	DDSetColorKey(m_lpDDHra.m_lpDDS,RGB(255,0,255));
	m_lpDDHra.m_PixelHeight = 1;
	m_lpDDHra.m_PixelWidth  = 1;
	
	// tvorba fontu
	m_thread = NULL;

	m_font.CreateFont(15,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman
}
//******************************************************************************
CHra::~CHra()
{
	m_font.Detach();
	t_kill = true;
	while(m_thread != NULL);
}
//******************************************************************************
// Activate
void CHra::Activate()
{
	m_toredraw = 0;
	ZobrazKurzor(TRUE);
}
//******************************************************************************
// Draw
BOOL CHra::Draw()
{

	if(m_tahne != NIC) {
		// update casu
		m_cas[m_tahne] += timeGetTime() - m_t1;
		m_t1 = timeGetTime();
	}

	if(--m_toredraw  > 0) return FALSE;


	CRect rcRect;

	CString s;

	rcRect.SetRect(0,0,640,480);
	// placneme pozadi
	m_lpDDAll.SetSrc(0,0,480,640);
	m_lpDDAll.DrawFast(0,0,screen.m_lpDDSBack);
	// napsani poctu bodu
	m_lpDDHra.SetSrc(0,0,20,20);
	for(int i = 5; i < m_p.cx + 5; i++)
		for(int j = 5; j < m_p.cy + 5; j++) {
			if(m_plocha[i][j] > 1) continue;
			if(m_plocha[i][j] == KRIZEK) 
				m_lpDDHra.SetSrc(0,0,20,20);
			else 
				m_lpDDHra.SetSrc(21,0,41,20);
			m_lpDDHra.SetDest((j-5)*480/m_p.cy+2,(i-5)*640/m_p.cx+2,(j-4)*480/m_p.cy-4,(i-4)*640/m_p.cx-4),
			m_lpDDHra.DrawTrans((i-5)*640/m_p.cx,(j-5)*480/m_p.cy,screen.m_lpDDSBack);
//			m_lpDDHra.Draw(screen.m_lpDDSBack);
//			m_lpDDHra.DrawScaled((i-5)*640/m_p.cx+3, (j-5)*480/m_p.cy+3, 
//				                  30, 30, screen.m_lpDDSBack);
		//		                  640/m_p.cx-6, 480/m_p.cy-6, screen.m_lpDDSBack);
//			if(screen.m_lpDDSBack->m_lpDDS->Blt(&m_lpDDHra.DestRect, m_lpDDHra.m_lpDDS, &m_lpDDHra.SrcRect, DDBLT_WAIT|DDBLT_KEYSRC, NULL)
//				 == DDERR_SURFACELOST) m_lpDDHra.Restore();
		}

	screen.m_lpDDSBack->GetDC();
	screen.m_lpDDSBack->ChangeFont("Verdena",0,20);
	screen.m_lpDDSBack->SetFont();
//	screen.m_lpDDSBack->DrawText("Test",RGB(255,0,0),CRect(50,400,150,450));
	s.Format("%d s",m_cas[0]/1000);
	screen.m_lpDDSBack->TextXY(50,450,RGB(0,150,0),s);
	s.Format("%d s",m_cas[1]/1000);
	screen.m_lpDDSBack->TextXY(450,450,RGB(0,0,200),s);
	screen.m_lpDDSBack->ReleaseDC();

//	m_toredraw = 20;
	m_toredraw = 2;

	return TRUE;
}
//******************************************************************************
// Restore
void CHra::Restore()
{

}
//******************************************************************************
// Arbitraz hry
//******************************************************************************
// NovaHra
void CHra::NovaHra(int pl1, int pl2, int plochax, int plochay, int zacina)
{
	m_hrac[0] = pl1;
	m_hrac[1] = pl2;
	m_p.cx = plochax;
	m_p.cy = plochay;
	m_tahne = zacina;
	m_cas[0] = 0;
	m_cas[1] = 0;
	m_tah = 0;
	m_t1  = 0;
	t_kill = true; // pro jistotu
	// smazani hraci plochy
	for (int i = 0; i < PLOCHAX+10; i++)
		for (int j = 0; j < PLOCHAY+10; j++)
			if ((i < 5)||(j < 5)||(i > m_p.cx+4)||(j > m_p.cy+4)) m_plocha[i][j] = KRAJ;
			else m_plocha[i][j] = NIC;

	DalsiTah(); // a jedem
}
//******************************************************************************
// Tahnul
void CHra::Tahnul(CPoint kam)
{
	int rv;
	// test, zda je mozno tah udelat, jinak DalsiTah
	m_cas[m_tahne] += timeGetTime() - m_t1;

	// provedeni tahu
	if((kam.x >4 && kam.y > 4 && kam.x < m_p.cx + 5 && kam.y < m_p.cy + 5) &&
		(m_plocha[kam.x][kam.y] == NIC)) {
		m_plocha[kam.x][kam.y] = m_tahne;

		m_toredraw = 0;
		
		// tah se provedl
		m_tah++; // povedlo se udelat dalsi tah
		rv = Konec(); // otestujeme na konec
		if(rv == NIC) {
			if(m_tahne == KRIZEK) m_tahne = KOLECKO;
			else m_tahne = KRIZEK;
			DalsiTah();
		} else 
			m_tahne = NIC;
	}
	else DalsiTah(); // hrac pravdepodobne kliknul vedle
}
//******************************************************************************
// DalsiTah
void CHra::DalsiTah()
{
	if(m_tahne == NIC) return; // jistota

	m_t1 = timeGetTime();
	// spsteni threadu
	if(m_hrac[m_tahne] == POCITAC) {

		t_kill = true;
		m_thread = NULL;
		// spusteni treadu
		m_rand = rand();
		m_thread = AfxBeginThread(t_Tahni,this,THREAD_PRIORITY_NORMAL);
	}
}
//******************************************************************************
// Messages
//******************************************************************************
// OnTimer
BOOL CHra::OnTimer()
{
	// hraje - li pocitac
	return Draw();
}
//******************************************************************************
// OnKeyDown
void CHra::OnKeyDown(UINT nChar)
{
	if(nChar == VK_ESCAPE) {
		t_kill = true;
		while(t_running) t_kill = true;
		AfxGetApp()->m_pMainWnd->SendMessage(WM_MENU,0,0);
	}
}
//******************************************************************************
// OnLButtonDown
void CHra::OnLButtonDown(CPoint point)
{

}
//******************************************************************************
// OnMouseMove
void CHra::OnMouseMove(CPoint point)
{

}
//******************************************************************************
// OnLButtonUp
void CHra::OnLButtonUp(CPoint point)
{
	if(m_hrac[m_tahne] == CLOVEK)
		Tahnul(CPoint(point.x*m_p.cx/640+5,point.y*m_p.cy/480+5));
}
//******************************************************************************
// Diagnostika hry
//******************************************************************************
// Konec
int CHra::Konec()
{
	int i,j;
	bool nic = false;

	for(i = 5; i < m_p.cx+5; i++)
		for(j = 5; j < m_p.cy+5; j++){
			// vertikalne
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i+1][j])&&
				(m_plocha[i][j]==m_plocha[i+2][j])&&
				(m_plocha[i][j]==m_plocha[i+3][j])&&
				(m_plocha[i][j]==m_plocha[i+4][j])) return m_plocha[i][j];

			// horizontalne
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i][j+1])&&
				(m_plocha[i][j]==m_plocha[i][j+2])&&
				(m_plocha[i][j]==m_plocha[i][j+3])&&
				(m_plocha[i][j]==m_plocha[i][j+4])) return m_plocha[i][j];

			// sikmo 
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i+1][j+1])&&
				(m_plocha[i][j]==m_plocha[i+2][j+2])&&
				(m_plocha[i][j]==m_plocha[i+3][j+3])&&
				(m_plocha[i][j]==m_plocha[i+4][j+4])) return m_plocha[i][j];

			// sikmo
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i-1][j+1])&&
				(m_plocha[i][j]==m_plocha[i-2][j+2])&&
				(m_plocha[i][j]==m_plocha[i-3][j+3])&&
				(m_plocha[i][j]==m_plocha[i-4][j+4])) return m_plocha[i][j];
	
			if (m_plocha[i][j] == NIC) nic = true;
		}
	if ((nic = false)||(m_tah==m_p.cx*m_p.cy)) {
		m_tahne = NIC;
		return KRAJ;
	}
	return NIC;
	
}
//******************************************************************************
// Hledej
int CHra::Hledej(CPoint pt, int p, int d, int t, int c, int s)
{
	int pocet = 0;
	
	//  * ? ? ? ? ?
	// * p d t c s
	// * = zadany bod
	// nema smysl premyslet
	if (m_plocha[pt.x][pt.y] != NIC) return 0;

// vertikalne :	
	// nahoru :
	if (((m_plocha[pt.x][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// dolu:
	if (((m_plocha[pt.x][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+5]==s)||(s==COKOLI))) pocet++;
	
// horizontalne :
	// doleva :
	if (((m_plocha[pt.x-1][pt.y]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y]==s)||(s==COKOLI))) pocet++;
	 
	// doprava :
	if (((m_plocha[pt.x+1][pt.y]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y]==s)||(s==COKOLI))) pocet++;	

// 1. diagonala :
	// doleva nahor :
	if (((m_plocha[pt.x-1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// doprava dolu :
	if (((m_plocha[pt.x+1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y+5]==s)||(s==COKOLI))) pocet++;

// 2. diagonala :
	// doprava dolu :
	if (((m_plocha[pt.x-1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y+5]==s)||(s==COKOLI))) pocet++;

	// doprava nahoru :
	if (((m_plocha[pt.x+1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y-5]==s)||(s==COKOLI))) pocet++;

	return pocet;
}
//******************************************************************************
// Hledej_inline
int CHra::Hledej_inline(CPoint pt, int l3, int l2, int l1, int p1, int p2, int p3)
{
	int pocet = 0;

   // aby se jedno moznost nepocitala 2* -> zdvojeni ifu - [symetricke zadani]
	// ? ? ? * ? ? ?
	// l3 l2 l1 * p1 p2 p3
	// * = zadany bod
	// nema smysl premyslet
	if (m_plocha[pt.x][pt.y] != NIC) return 0;

// vertikalne :
	// nahoru l:
	if (((m_plocha[pt.x][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// dolu l:
	if (((m_plocha[pt.x][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;

// vertikalne :
	// doleva l:
	if (((m_plocha[pt.x-1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y]==p3)||(p3==COKOLI)) ) pocet++;
	else 
	// doprava l:
	if (((m_plocha[pt.x-1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y]==l3)||(l3==COKOLI)) ) pocet++;

// 1. diagonala :
	// doleva nahoru l:
	if (((m_plocha[pt.x-1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// doprava dolu l:
	if (((m_plocha[pt.x-1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	
// 2. diagonala :
	// doprava nahoru l:
	if (((m_plocha[pt.x+1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x-1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x-3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	else 
	// doleva dolu l:
	if (((m_plocha[pt.x+1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x-1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x-3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;

	return pocet;
}

//******************************************************************************
//
// Myslici proces zacina tady 
//
//******************************************************************************
// t_Tahni
UINT t_Tahni(LPVOID p_hra){
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHra *h = (CHra*) p_hra;
	if(h->Konec() != NIC) return 0;
	srand(h->m_rand);
	// myslici proces


// tohle je algoritmus random - nepouzivat !
	h->Tahnul(CPoint(Nahoda(h->m_p.cx)+5,Nahoda(h->m_p.cy)+5));

	t_running = false;
	h->m_thread = NULL;
	return 0;
}



/*
UINT t_Tahni(LPVOID p_hra){
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHra *h = (CHra*) p_hra;
	if(h->Konec() != NIC) return 0;
	srand(h->m_rand);
	// myslici proces

	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k,m;
	CPoint po;

	int X = h->m_tahne;
	int O;
	if(X == KRIZEK) O = KOLECKO;
	else O = KRIZEK;
	int N = NIC;
	int C = COKOLI;

	if (h->m_tah == 0) { // zpracovani 1. tahu
		kam.x = (h->m_p.cx/2) - 5 + Nahoda(10)+5;
		kam.y = (h->m_p.cy/2) - 5 + Nahoda(10)+5;
	}
	else {
		// init pole
		max = -3;
		cnt = -1;
		for (po.x = 5; po.x < h->m_p.cx+5; po.x++)
			for (po.y = 5; po.y < h->m_p.cy+5; po.y++) {
				k = 0;
				// vyhrane situace :
				k += 100000 * h->Hledej(po,X,X,X,X,C);
				k += 100000	* h->Hledej_inline(po,C,X,X, X,X,C); 	
				k += 100000 * h->Hledej_inline(po,X,X,X, X,C,C);
				
				// temer smrt
				k +=  80000 * h->Hledej(po,O,O,O,O,C);  //				*OOOO
				k +=  80000 * h->Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
				k +=  80000 * h->Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O
	
				// temer vyhrane :
				k +=  60000 * h->Hledej_inline(po,N,X,X, X,N,C);  // _XX*X_
				if (((h->Hledej(po,X,X,X,N,C) > 0))&&(h->Hledej_inline(po,C,C,N, X,X,X)>0)) k += 60000; // _XXX*_

				// kriticke situace :
				k +=  50000 * h->Hledej_inline(po,C,N,O, O,O,N);       //_O*OO_
				if (h->Hledej_inline(po,C,C,N, O,O,N)>1) k+= 40000; // _*OO_ && _*OO_
				if ((h->Hledej(po,O,O,O,N,C)>0)&&(h->Hledej_inline(po,C,C,N, O,O,O)>0)) k += 50000;	// 	_*OOO_
				else if (h->Hledej(po,O,O,O,C,C)>1) k += 40000;     //  *OOO && *OOO
						else k +=  35000 * h->Hledej(po,O,O,O,N,C); // *OOO_
				if ((h->Hledej(po,O,O,O,C,C)>0)&&(h->Hledej(po,O,O,N,C,C)>0)) k += 30000; // *OOO && *OO_
				if (h->Hledej_inline(po,N,N,O, O,N,C) > 1) k+= 40000; //					  O	
//																									_O*O__		
//																									  O	
			
				// zajimave situace + pasti :
				if ( k < 40000) {
					if ((h->Hledej_inline(po,N,N,X, X,N,C)) > 1) k+= 20000; //				  X	
//																										_X*X__		
//																										  X	
					if ((h->Hledej(po,X,X,X,C,C)>0)&&(h->Hledej(po,X,X,N,C,C)>0)) k += 20000; // *XXX && *XX_					
					if ((h->Hledej_inline(po,C,C,N, X,X,N)>0)&&(h->Hledej_inline(po,C,C,N, N,X,X)>0)) k+= 30000; // _*XX_ &&   _*_XX
					if ((m =  30000 * h->Hledej(po,X,X,X,N,C)) > 0) k += m ;  // *XXX_
					else if(Nahoda(5) > 3) k +=  25000 * h->Hledej(po,X,X,X,C,C);  // *XXX
					k +=   8000 * h->Hledej_inline(po,N,X,X, X,C,C); // _XX*X 
					if (m = h->Hledej_inline(po,N,N,O, O,N,N)) k += 2500; // __O*O__
					else k +=   1000 * h->Hledej_inline(po,C,N,O, O,N,C); //  _O*O_
					if ((m = h->Hledej_inline(po,C,N,N, O,O,N)) > 1) k+=  5000 * m; // __*OO_
					if ((m = h->Hledej(po,O,C,C,C,C)>3)) k+= 700; // trochu moc O
				}

			// standart :
				if ((m = h->Hledej_inline(po,C,C,N, X,X,N))>0) k +=   1000 * m; // _*XX_
				else k +=    500 * h->Hledej(po,X,X,N,C,C);  // *XX_
				k +=    500 * h->Hledej(po,N,X,X,C,C);	// *_XX
				k +=    900 * h->Hledej(po,N,X,N,X,C);	// *_X_X
				k +=   1100 * h->Hledej_inline(po,C,N,X, X,N,C); // _X*X_
				k +=    500 * h->Hledej(po,O,O,N,C,C);	// *OO_
				k +=    300 * h->Hledej(po,X,N,C,C,C); // *X_
				k +=	  200 * h->Hledej(po,O,N,C,C,C); // *O_
				k +=      5 * h->Hledej(po,X,C,C,C,C); // *X
				k +=      4 * h->Hledej(po,O,C,C,C,C); // *O
			
			// zarazeni do moznosti
			if ((abs(k - max) <= 100)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			}
	
			// nejlepsi moznost - smazani predchozich vysledku
			if ( k > max + 100) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			}
		}
	
		// vybrani vysledku ( nahodne )
		kam = body[Nahoda(cnt+1)]; 
	} //	if (h->m_tah == 0) {} else {

	// navrat
	h->Tahnul(kam);

// tohle je algoritmus random - nepouzivat !
//	h->Tahnul(CPoint(Nahoda(h->m_p.cx)+5,Nahoda(h->m_p.cy)+5));

	t_running = false;
	h->m_thread = NULL;
	return 0;
}

  
	 **/