/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  hra.h
/*******************************************************************************/
// definuje hraci prostredi

#if !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
#define AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// co je na plose
#define KRIZEK  0 // slouzi i jako m_tahne
#define KOLECKO 1 // slouzi i jako m_tahne
#define NIC     2 // prazdne policko
#define COKOLI  3 // slouzi pri urcovanitahu pocitace
#define KRAJ    4 // slouzi pro ohraniceni

/// maximalni mozne rozmery plochy
#define PLOCHAX 40
#define PLOCHAY 40

// kdo je co
#define CLOVEK  0
#define POCITAC 1
// definice obtiznosti - zatim nefunguje
#define UTOCNIK 7
#define OBRANAR 6
#define DEMO 5
#define HARD 4
#define MEDIUM 3
#define EASY 2


class CHra : public Base 
{
public:
	void DalsiTah();
	void Activate(); // oznamuje, ze se hra stala aktivni
	CHra();          // konstruktor
	virtual ~CHra(); // destrukktor
	BOOL Draw();     // vykresli aktualinni stav do back surface
	int Hledej(CPoint pt,int p,int d, int t, int c, int s);  // hleda v hraci pose
	int Hledej_inline(CPoint pt,int l3,int l2, int l1, int p1, int p2, int p3);
	int Konec(); // vrati, zda nekdo vyhral
	void NovaHra(int pl1, int pl2, int plochax, int plochay, int zacina); // inicializuje novou hru
	void OnKeyDown(UINT nChar);       // uzivatel neco stiskl
	void OnLButtonDown(CPoint point); // zprava mysi
	void OnLButtonUp(CPoint point);   // zprava mysi
	void OnMouseMove(CPoint point);   // zprava mysi
	BOOL OnTimer();  // odezva hlavniho timeru ( 40 ms )
	void Restore();  // pri ztrate surfacu
	void Tahnul(CPoint kam); // kam tahnul nas hrac ?


	// bitmapy
	CDXSurface     m_lpDDAll;    // pozadi
	CDXSurface     m_lpDDHra;    // ostatni - semafor,ramovani,...

	CFont m_font;  // hlavni font
	CWinThread *m_thread; // drzime si ukazatel
	int   m_t1; // stratovni cas jednoho tahu
	int   m_toredraw;

	int m_plocha[PLOCHAX+10][PLOCHAY+10]; // hraci polcha
	CSize m_p;    // plocha ( rozmery )
	int m_tah;    // cilso tahu
	int m_tahne; // 1 , 2
	int m_hrac[2];  // kdo hraje
	int m_cas[2];    // jak dlouho
	int m_rand;
};

#endif // !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
