/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  MainFrm.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "PiskII.h"

#include "bbuttonek.h"

// casti hry
#include "menu.h"

#include "MainFrm.h"

//******************************************************************************
IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,Init)
	ON_MESSAGE(WM_MENU,WmMenu)
	ON_MESSAGE(WM_HRA,WmHra)
END_MESSAGE_MAP()

//******************************************************************************
CMainFrame::CMainFrame()
{
	CRect rect;
	rect.bottom = 480;
	rect.left = 0;
	rect.right = 640;
	rect.top = 0;

	CreateEx(WS_EX_TOPMOST,NULL,"Piskvorky II",
			   WS_POPUP , rect, NULL, 0);

	m_uTimerID = SetTimer(5,40,NULL);

	m_menu1 = NULL;
	m_hra = NULL;
	m_pactual = NULL;
}
//******************************************************************************
CMainFrame::~CMainFrame()
{
//	KillTimer(m_uTimerID);
	
	m_pactual = NULL;
	if(m_menu1) delete m_menu1;
	if(m_hra)   delete m_hra;
}
//******************************************************************************
void CMainFrame::Init(int parama, int paramb)
{
	ZobrazKurzor(FALSE);
	// loadingovani

	// + nacteni
	m_hra = new CHra;
	m_menu1 = new CMenu1;
	WmMenu(0,0);
	SendMessage(WM_TIMER);
}

//******************************************************************************
BOOL CMainFrame::RestoreAll()
{
	screen.Restore();

	m_hra->Restore();

	// zniceni ramecku okolo
	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
	SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);


	return TRUE;
}
//******************************************************************************
void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	screen.FadeToBlack(100);
}
//******************************************************************************
void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_pactual->OnKeyDown(nChar);

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonDown(point);
	
	CFrameWnd::OnLButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonUp(point);
	CFrameWnd::OnLButtonUp(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_pactual->OnMouseMove(point);
	CFrameWnd::OnMouseMove(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);
	if(m_pactual == NULL) return;
	
	if(m_pactual->OnTimer() == TRUE)
		screen.Flip();

}
//******************************************************************************
void CMainFrame::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_pactual->OnKeyUp(nChar);
	CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::WmMenu(int parama, int paramb)
{
	ZobrazKurzor(FALSE);
	screen.FadeToBlack(1000);
	m_menu1->Activate(m_hra);
	m_pactual = m_menu1;
	m_pactual->OnTimer();
	screen.FadeToSource(1000);
}
//******************************************************************************
void CMainFrame::WmHra(int parama, int paramb)
{
/*	switch(parama){
	case 1 : 
		break;
	case 2: 
		break;
	case 3: 
		break;
	}*/
	ZobrazKurzor(FALSE);
	screen.FadeToBlack(1000);
	m_hra->Activate();
	m_hra->NovaHra(parama,paramb,27,20,KOLECKO);
	m_pactual = m_hra;
	m_pactual->OnTimer();
	screen.FadeToSource(1000);
}
//******************************************************************************
void CMainFrame::WmRestore(int parama, int b)
{
	RestoreAll();
}
//******************************************************************************
void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonDown(point);
	CFrameWnd::OnRButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonUp(point);
	CFrameWnd::OnRButtonUp(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnClose() 
{
	ZobrazKurzor(FALSE);
	screen.FadeToBlack(1000);
	CFrameWnd::OnClose();
}
