// CreateCon.cpp : implementation file
//

#include "stdafx.h"
#include "PiskII.h"
#include "hra.h"
#include "CreateCon.h"
#include "modul4.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCreateCon dialog


CCreateCon::CCreateCon(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateCon::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateCon)
	m_vlastni = _T("");
	//}}AFX_DATA_INIT
	for(int i = 0; i < 40; i++)
		m_sess[i].m_Name = new char[40];

	m4_event = CreateEvent(NULL,		// no security
								 FALSE,		// auto reset
								 FALSE,		// initial event reset
								 NULL);		// no name
}

CCreateCon::~CCreateCon()
{
	for(int i = 0; i < 40; i++)
		delete [40] m_sess[i].m_Name;
}


void CCreateCon::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateCon)
	DDX_Control(pDX, IDC_STAV, m_stav);
	DDX_Control(pDX, IDC_STORNO, m_storno);
	DDX_Control(pDX, IDC_SESSIONLIST, m_sessoins);
	DDX_Control(pDX, IDC_JOIN, m_join);
	DDX_Control(pDX, IDC_HOST, m_host);
	DDX_Control(pDX, IDC_CONTYPE, m_contype);
	DDX_Text(pDX, IDC_VLASTNI, m_vlastni);
	DDV_MaxChars(pDX, m_vlastni, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateCon, CDialog)
	//{{AFX_MSG_MAP(CCreateCon)
	ON_BN_CLICKED(IDC_HOST, OnHost)
	ON_BN_CLICKED(IDC_JOIN, OnJoin)
	ON_CBN_SELCHANGE(IDC_CONTYPE, OnSelchangeContype)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STORNO, OnStorno)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCreateCon message handlers

void CCreateCon::OnCancel() 
{
	t_kill = true; // zabijeme pripadna vlakna
	if(connected == TRUE) 
		OnStorno();

	CDialog::OnCancel();
}

void CCreateCon::OnOK() 
{
	
//	CDialog::OnOK();
}

void CCreateCon::OnHost() 
{
	UpdateData();
	if(m_vlastni.IsEmpty()) {
		MessageBox("Musite zadat jmeno hry","Chyba");
		return;
	}

	if(connected == TRUE) {
		link.CloseSession();
		connected = FALSE;
	}

	// hostnuti
	CDXLinkSession ses;
	ses.m_AppGuid = pikII_GUID;
	ses.m_MaxPlayers = 2;
	ses.m_Flags = DPSESSION_CLIENTSERVER;
	ses.m_Name = (char*) malloc(sizeof(char)*30);
	strcpy(ses.m_Name,m_vlastni);
	if(!link.HostSession(&ses)) {
		MessageBox("Nepodarilo se udelat Host","Chyba");
		return;
	}

	// tvorba hrace 
	player.m_Flags = DPPLAYER_SERVERPLAYER;
//	player.m_Name  = (char*) malloc(sizeof(char)*10);
//	player.m_Name  = "Krizek";
	player.m_Name  = NULL;
	player.m_Event = m4_event;
	if(!link.CreatePlayer(&player)) {
		link.CloseSession();
		MessageBox("Nepodarilo se vytvorit hrace","Chyba");
		return;
	}
	player.m_Flags = 0;

	connected = TRUE;

	// cekani na 2. hrace
	m_stav.SetWindowText("Cekam na 2. hrace...");

	m_storno.EnableWindow(TRUE);
	m_join.EnableWindow(FALSE);
	m_host.EnableWindow(FALSE);

	AfxBeginThread(m4_t_ConnServer,(LPVOID)this,THREAD_PRIORITY_NORMAL);
}

void CCreateCon::OnJoin() 
{
	TRACE("On Join\n");
	if(connected == TRUE) {
		link.CloseSession();
		connected = FALSE;
	}

	if(!link.JoinSession(&m_sess[m_sessoins.GetCurSel()])){
		MessageBox("Nepodarilo se Joinnout","Chyba");
		return;
	}

	player.m_Flags = 0;
	player.m_Name  = NULL;
	player.m_Event = m4_event;
	if(!link.CreatePlayer(&player)) {
		link.CloseSession();
		MessageBox("Nepodarilo se vytvorit hrace","Chyba");
		return;
	}
	player.m_Flags = 1;

	TRACE("Enternir loop..\n");

	connected = TRUE;

	// cekani na server
	m_stav.SetWindowText("Cekam na odpoved serveru...");
	
	m_storno.EnableWindow(TRUE);
	m_join.EnableWindow(FALSE);
	m_host.EnableWindow(FALSE);

	TRACE("Starting Thread..\n");
	AfxBeginThread(m4_t_ConnClient,(LPVOID)this,THREAD_PRIORITY_NORMAL);
}

void CCreateCon::OnSelchangeContype() 
{
	// novy typ spojeni
	m_join.EnableWindow(FALSE);

	while (m_sessoins.GetCount() > 0) m_sessoins.DeleteString(0);
	if (m_contype.GetCurSel() == 0) {
		m_stav.SetDlgItemText(0,"Vyberte typ spojeni");
		m_host.EnableWindow(FALSE);
		return;
	}
	if (m_contype.GetCurSel() == 1) if(!link.CreateSerial(&AfxGetApp()->m_pMainWnd->m_hWnd)) {
		MessageBox("Selhalo navazani po seriovem kabelu.","Chyba");
		return;
	}

	if (m_contype.GetCurSel() == 2) if(!link.CreateIPX(&AfxGetApp()->m_pMainWnd->m_hWnd)) {
		MessageBox("Selhalo navazani IPX komunikace.","Chyba");
		return;
	}

	link.EnumSessions((CDXLinkSession *)&m_sess,pikII_GUID);
	for(int i = 0; i < SessionCount; i++)
		m_sessoins.AddString(m_sess[i].m_Name);

	m_host.EnableWindow(TRUE);

}

BOOL CCreateCon::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(connected == TRUE) {
		link.CloseSession();
		connected = FALSE;
	}

	m_join.EnableWindow(FALSE);
	m_host.EnableWindow(FALSE);
	m_storno.EnableWindow(FALSE);

	m_contype.AddString("<- Vyberte typ spojeni ->");
	m_contype.AddString(" Seriove po kabelu ");
	m_contype.AddString(" IPX spojeni       ");
	m_contype.SetCurSel(0);

	while(m_sessoins.GetCount() > 0) m_sessoins.DeleteString(0);


	SetTimer(3,4000,NULL); // na refresh her
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCreateCon::OnTimer(UINT nIDEvent) 
{
		int i = m_sessoins.GetCurSel();

		while (m_sessoins.GetCount() > 0) m_sessoins.DeleteString(0);
	
		link.EnumSessions((CDXLinkSession *)&m_sess,pikII_GUID);
		for(int j = 0; j < SessionCount; j++)
			m_sessoins.AddString(m_sess[j].m_Name);

		if((m_sessoins.GetCount() > i) && (i != LB_ERR)) {
			m_sessoins.SetCurSel(i);
			m_join.EnableWindow(TRUE);
		}
		else 
			m_join.EnableWindow(TRUE); //!!!!!!!!!

	CDialog::OnTimer(nIDEvent);
}

int CCreateCon::DoModal(CHra *pHra)
{
	m_pHra = pHra;
	return CDialog::DoModal();
}

void CCreateCon::OnStorno() 
{

	m_storno.EnableWindow(FALSE);
	t_kill = true;
	if(connected == TRUE)
		link.CloseSession();
	connected = FALSE;
	if(m_sessoins.GetCurSel() != LB_ERR)
		m_join.EnableWindow(TRUE);
	else
		m_join.EnableWindow(TRUE); //!!!!!!!!!

	m_host.EnableWindow(TRUE);

}

void CCreateCon::ServerOK()
{
	m_storno.EnableWindow(FALSE);
	TRACE("Onok\n");
	EndDialog(IDOK);
}

void CCreateCon::ClientOK()
{
	TRACE("client ok\n");
	m_storno.EnableWindow(FALSE);
	TRACE("Onok\n");
	EndDialog(IDOK);
	TRACE("No problem\n");
}
