/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  hra.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "PiskII.h"
#include "Hra.h"

//pridani modulu
#include "Modul1.h"
#include "Modul2.h"
#include "Modul3.h"
#include "Modul5.h"
#include "Modul6.h"

#include "Modul4.h" // network

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// komunikace s thready
bool t_kill = false;
bool t_hotovo = false;
bool t_running = false;


//******************************************************************************
// Inicializace
//******************************************************************************
CHra::CHra()
{
	m_lpDDAll.m_lpDDS = DDLoadBitmapB(screen.m_lpDD,"IDB_ZED", 0, 0, AfxGetApp()->m_hInstance);
	if (m_lpDDAll.m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	
	m_lpDDXO[0].m_lpDDS = DDLoadBitmapB(screen.m_lpDD, "IDB_X", 0, 0, AfxGetApp()->m_hInstance);
	if (m_lpDDXO[1].m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	m_lpDDXO[1].m_lpDDS = DDLoadBitmapB(screen.m_lpDD, "IDB_O", 0, 0, AfxGetApp()->m_hInstance);
	if (m_lpDDXO[1].m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	m_lpDDXO[2].m_lpDDS = DDLoadBitmapB(screen.m_lpDD, "IDB_M", 0, 0, AfxGetApp()->m_hInstance);
	if (m_lpDDXO[2].m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

        // load alpha mask
   m_lpDDXOA[0] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_X1", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[0] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
   
   m_lpDDXOA[1] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_X2", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[1] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_lpDDXOA[2] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_X3", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[2] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_lpDDXOA[3] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_O1", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[3] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_lpDDXOA[4] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_O2", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[4] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_lpDDXOA[4] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_A_O3", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_lpDDXOA[4] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	// init DDSURFACEDESC2 for the mask
	BITMAP bm;
	for(int i = 0; i < MAX_TYPES; i++) {
		GetObject(m_lpDDXOA[i], sizeof(bm), &bm);
      m_lpDesAlp[i].dwWidth   = bm.bmWidth;
      m_lpDesAlp[i].dwHeight  = bm.bmHeight;
      m_lpDesAlp[i].lPitch    = bm.bmWidthBytes;
      m_lpDesAlp[i].lpSurface = bm.bmBits;
	}

	// tvorba fontu
	m_thread = NULL;

	m_font.CreateFont(15,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman\

	//default init
	m_hrac[0] = 0;
	m_hrac[1] = 0;
	m_cas[0] = 0;
	m_cas[1] = 0;
	m_p.cx = 1;
	m_p.cy = 1;
	m_tah = 0;

	m_plr.x = 0;
	m_plr.y = 0;
}
//******************************************************************************
CHra::~CHra()
{
	m_font.Detach();
	for(int i = 0; i < MAX_TYPES; i++)
	   if (m_lpDDXOA[i] != NULL) DeleteObject(m_lpDDXOA[i]);

	t_kill = true;
	while(m_thread != NULL);
}
//******************************************************************************
// Activate
void CHra::Activate()
{
	m_toredraw = 0;
	ZobrazKurzor(TRUE);
}
//******************************************************************************
// Arbitraz hry
//******************************************************************************
// NovaHra
void CHra::NovaHra(int pl1, int pl2, int plochax, int plochay, int zacina)
{
	m_hrac[0] = pl1;
	m_hrac[1] = pl2;
	// zapnuti receive thread v piskII
	t_kill = true; // pro jistotu
	if((pl1 == MODUL4)||(pl2 == MODUL4)) {
		m_thread = AfxBeginThread(m4_t_Tahni,this,THREAD_PRIORITY_NORMAL);
	}

	m_p.cx = plochax;
	m_p.cy = plochay;
	m_tahne = zacina;
	m_cas[0] = 0;
	m_cas[1] = 0;
	m_tah = 0;
	m_t1  = 0;
	// smazani hraci plochy
	for (int i = 0; i < PLOCHAX+10; i++)
		for (int j = 0; j < PLOCHAY+10; j++) {
			if ((i < 5)||(j < 5)||(i > m_p.cx+4)||(j > m_p.cy+4))
				m_plocha[i][j] = KRAJ;
			else
				m_plocha[i][j] = NIC;
			m_plochaD[i][j] = MAX_TYPES;
		}
	DalsiTah(); // a jedem
}
//******************************************************************************
// Tahnul
void CHra::Tahnul(CPoint kam)
{
	int rv;
	// test, zda je mozno tah udelat, jinak DalsiTah
	m_cas[m_tahne] += timeGetTime() - m_t1;

	// provedeni tahu
	if((kam.x >4 && kam.y > 4 && kam.x < m_p.cx + 5 && kam.y < m_p.cy + 5) &&
		(m_plocha[kam.x][kam.y] == NIC)) {
		m_plocha[kam.x][kam.y] = m_tahne;
		if(m_tahne == KRIZEK)
			m_plochaD[kam.x][kam.y] = Nahoda(X_TYPES);
		else 
			m_plochaD[kam.x][kam.y] = X_TYPES + Nahoda(Y_TYPES);

		m_toredraw = 0;
		
		// tah se provedl
		m_tah++; // povedlo se udelat dalsi tah
		rv = Konec(); // otestujeme na konec
		if(rv == NIC) {
			if((m_hrac[0] == MODUL4) ||
				(m_hrac[1] == MODUL4)) {
					st_message mess; // poslani zpravy
					mess.message = MESS_TAH;
					mess.type = m_tahne;
					mess.x = kam.x;
					mess.y = kam.y;
					SendMess(mess);
			}
			if(m_tahne == KRIZEK) m_tahne = KOLECKO; // prohodime, kdo je na tahu
			else m_tahne = KRIZEK;
			DalsiTah();
		} else 
			m_tahne = NIC;
	}
	else DalsiTah(); // hrac pravdepodobne kliknul vedle
}
//******************************************************************************
// DalsiTah
void CHra::DalsiTah()
{
	if(m_tahne == NIC) return; // jistota

	m_t1 = timeGetTime();
	// spsteni threadu
	if(m_hrac[m_tahne] > CLOVEK) { // hraje pocitac
		if(m_tahne != MODUL4) {
			t_kill = true;
			m_thread = NULL;
		}
		// spusteni treadu
		m_rand = rand();
		switch (m_hrac[m_tahne]){
		case MODUL1 :
			m_thread = AfxBeginThread(m1_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
		case MODUL2 :
			m_thread = AfxBeginThread(m2_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
		case MODUL3 :
			m_thread = AfxBeginThread(m3_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
		case MODUL5 :
			m_thread = AfxBeginThread(m5_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
		case MODUL6 :
			m_thread = AfxBeginThread(m6_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
/*		case MODUL4 : // multi player
			m_thread = AfxBeginThread(m4_t_Tahni,this,THREAD_PRIORITY_NORMAL);
			break;
*/		}
	}
}
//******************************************************************************
// Messages
//******************************************************************************
// OnTimer
BOOL CHra::OnTimer()
{
	// hraje - li pocitac
	return Draw();
}
//******************************************************************************
// OnKeyDown
void CHra::OnKeyDown(UINT nChar)
{
	st_message mes;
	switch(nChar) {
	case VK_ESCAPE :
		mes.message = MESS_END;
		SendMess(mes);
		Done();
		break;
	default :
		if(m_tahne == NIC) Done();
		break;
	}
}
//******************************************************************************
// OnLButtonDown
void CHra::OnLButtonDown(CPoint point)
{

}
//******************************************************************************
// OnMouseMove
void CHra::OnMouseMove(CPoint point)
{
	if(m_hrac[m_tahne] == CLOVEK) {
		m_plr.x = point.x*m_p.cx/640;
		m_plr.y = point.y*m_p.cy/480;
		m_toredraw = 0;
		if((m_hrac[0] == MODUL4) ||
			(m_hrac[1] == MODUL4)) {
			st_message mess;
			mess.message = MESS_MYS;
			mess.x  = m_plr.x;
			mess.y  = m_plr.y;
			SendMess(mess);
		}

	}
}
//******************************************************************************
// OnLButtonUp
void CHra::OnLButtonUp(CPoint point)
{
	if(m_hrac[m_tahne] == CLOVEK)
		Tahnul(CPoint(point.x*m_p.cx/640+5,point.y*m_p.cy/480+5));
}
//******************************************************************************
// Diagnostika hry
//******************************************************************************
// Konec
int CHra::Konec()
{
	int i,j;
	bool nic = false;

	for(i = 5; i < m_p.cx+5; i++)
		for(j = 5; j < m_p.cy+5; j++){
			// vertikalne
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i+1][j])&&
				(m_plocha[i][j]==m_plocha[i+2][j])&&
				(m_plocha[i][j]==m_plocha[i+3][j])&&
				(m_plocha[i][j]==m_plocha[i+4][j])) return m_plocha[i][j];

			// horizontalne
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i][j+1])&&
				(m_plocha[i][j]==m_plocha[i][j+2])&&
				(m_plocha[i][j]==m_plocha[i][j+3])&&
				(m_plocha[i][j]==m_plocha[i][j+4])) return m_plocha[i][j];

			// sikmo 
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i+1][j+1])&&
				(m_plocha[i][j]==m_plocha[i+2][j+2])&&
				(m_plocha[i][j]==m_plocha[i+3][j+3])&&
				(m_plocha[i][j]==m_plocha[i+4][j+4])) return m_plocha[i][j];

			// sikmo
			if((NIC!=m_plocha[i][j])&&
				(m_plocha[i][j]==m_plocha[i-1][j+1])&&
				(m_plocha[i][j]==m_plocha[i-2][j+2])&&
				(m_plocha[i][j]==m_plocha[i-3][j+3])&&
				(m_plocha[i][j]==m_plocha[i-4][j+4])) return m_plocha[i][j];
	
			if (m_plocha[i][j] == NIC) nic = true;
		}
	if ((nic = false)||(m_tah==m_p.cx*m_p.cy)) {
		m_tahne = NIC;
		return KRAJ;
	}
	return NIC;
	
}
//******************************************************************************
// Hledej
int CHra::Hledej(CPoint pt, int p, int d, int t, int c, int s)
{
	int pocet = 0;
	
	//  * ? ? ? ? ?
	// * p d t c s
	// * = zadany bod
	// nema smysl premyslet
	if (m_plocha[pt.x][pt.y] != NIC) return 0;

// vertikalne :	
	// nahoru :
	if (((m_plocha[pt.x][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// dolu:
	if (((m_plocha[pt.x][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+5]==s)||(s==COKOLI))) pocet++;
	
// horizontalne :
	// doleva :
	if (((m_plocha[pt.x-1][pt.y]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y]==s)||(s==COKOLI))) pocet++;
	 
	// doprava :
	if (((m_plocha[pt.x+1][pt.y]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y]==s)||(s==COKOLI))) pocet++;	

// 1. diagonala :
	// doleva nahor :
	if (((m_plocha[pt.x-1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// doprava dolu :
	if (((m_plocha[pt.x+1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y+5]==s)||(s==COKOLI))) pocet++;

// 2. diagonala :
	// doprava dolu :
	if (((m_plocha[pt.x-1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x-4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x-5][pt.y+5]==s)||(s==COKOLI))) pocet++;

	// doprava nahoru :
	if (((m_plocha[pt.x+1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((m_plocha[pt.x+4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((m_plocha[pt.x+5][pt.y-5]==s)||(s==COKOLI))) pocet++;

	return pocet;
}
//******************************************************************************
// Hledej_inline
int CHra::Hledej_inline(CPoint pt, int l3, int l2, int l1, int p1, int p2, int p3)
{
	int pocet = 0;

   // aby se jedno moznost nepocitala 2* -> zdvojeni ifu - [symetricke zadani]
	// ? ? ? * ? ? ?
	// l3 l2 l1 * p1 p2 p3
	// * = zadany bod
	// nema smysl premyslet
	if (m_plocha[pt.x][pt.y] != NIC) return 0;

// vertikalne :
	// nahoru l:
	if (((m_plocha[pt.x][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// dolu l:
	if (((m_plocha[pt.x][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;

// vertikalne :
	// doleva l:
	if (((m_plocha[pt.x-1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y]==p3)||(p3==COKOLI)) ) pocet++;
	else 
	// doprava l:
	if (((m_plocha[pt.x-1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y]==l3)||(l3==COKOLI)) ) pocet++;

// 1. diagonala :
	// doleva nahoru l:
	if (((m_plocha[pt.x-1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// doprava dolu l:
	if (((m_plocha[pt.x-1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x-3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x+1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x+3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	
// 2. diagonala :
	// doprava nahoru l:
	if (((m_plocha[pt.x+1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((m_plocha[pt.x-1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((m_plocha[pt.x-3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	else 
	// doleva dolu l:
	if (((m_plocha[pt.x+1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((m_plocha[pt.x+2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((m_plocha[pt.x+3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((m_plocha[pt.x-1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((m_plocha[pt.x-2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((m_plocha[pt.x-3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;

	return pocet;
}

//******************************************************************************
// Grafika 
//******************************************************************************
// Draw
BOOL CHra::Draw()
{

	if(m_tahne != NIC) {
		// update casu
		m_cas[m_tahne] += timeGetTime() - m_t1;
		m_t1 = timeGetTime();
	}

	if(--m_toredraw  > 0) return FALSE;


	CRect rcRect;

	CString s;

	rcRect.SetRect(0,0,640,480);
	// placneme pozadi
	m_lpDDAll.SetSrc(0,0,480,640);
	m_lpDDAll.DrawFast(0,0,screen.m_lpDDSBack);

	// nakresleni X a O
	LockBuffers();
	for(int i = 5; i < m_p.cx + 5; i++)
		for(int j = 5; j < m_p.cy + 5; j++) {
			if(m_plochaD[i][j] >= MAX_TYPES) continue;
			alpha->AlphaBltEx(m_lpDesDst, (i-5)*640/m_p.cx+2, (j-5)*480/m_p.cy+2,
									m_lpDesSrc[m_plocha[i][j]], NULL, m_lpDesAlp[m_plochaD[i][j]]);
		}
	// kresleni pokusneo tahu cloveka
	if(((m_hrac[m_tahne] == CLOVEK) || ((m_hrac[m_tahne] == MODUL4)))&& (m_plochaD[m_plr.x+5][m_plr.y+5] >= MAX_TYPES))
		if(m_tahne == KRIZEK) 
			alpha->AlphaBltEx(m_lpDesDst, m_plr.x*640/m_p.cx+2, m_plr.y*480/m_p.cy+2,
					m_lpDesSrc[2], NULL, m_lpDesAlp[0]);
		else 
			alpha->AlphaBltEx(m_lpDesDst, m_plr.x*640/m_p.cx+2, m_plr.y*480/m_p.cy+2,
					m_lpDesSrc[2], NULL, m_lpDesAlp[X_TYPES]);
	UnlockBuffers();

	// napsani poctu bodu
	screen.m_lpDDSBack->GetDC();
	screen.m_lpDDSBack->ChangeFont("Verdena",0,20);
	screen.m_lpDDSBack->SetFont();
	s.Format("%d s",m_cas[0]/1000);
	screen.m_lpDDSBack->TextXY(50,450,RGB(0,150,0),s);
	s.Format("%d s",m_cas[1]/1000);
	screen.m_lpDDSBack->TextXY(450,450,RGB(0,0,200),s);
	screen.m_lpDDSBack->ReleaseDC();

	m_toredraw = 20; // cas k prekresleni ( pristimu )
//	m_toredraw = 2;

	return TRUE;
}
//******************************************************************************
// Restore
void CHra::Restore()
{

}
//******************************************************************************
void dxutil_InitStructure(DDSURFACEDESC& structure)
{
        ZeroMemory(&structure, sizeof(structure));
        structure.dwSize                              = sizeof(structure);
        structure.ddpfPixelFormat.dwSize = sizeof(structure);
}
//******************************************************************************
void CHra::LockBuffers()
{
	dxutil_InitStructure(m_lpDesSrc[0]);
	dxutil_InitStructure(m_lpDesSrc[1]);
	dxutil_InitStructure(m_lpDesSrc[2]);
	dxutil_InitStructure(m_lpDesDst);

	m_lpDDXO[0].m_lpDDS->Lock(NULL, &m_lpDesSrc[0], DDLOCK_WAIT, NULL);
	m_lpDDXO[1].m_lpDDS->Lock(NULL, &m_lpDesSrc[1], DDLOCK_WAIT, NULL);
	m_lpDDXO[2].m_lpDDS->Lock(NULL, &m_lpDesSrc[2], DDLOCK_WAIT, NULL);
	screen.m_lpDDSBack->m_lpDDS->Lock(NULL, &m_lpDesDst, DDLOCK_WAIT, NULL);
}
//******************************************************************************
void CHra::UnlockBuffers()
{
	m_lpDDXO[0].m_lpDDS->Unlock(NULL);
	m_lpDDXO[1].m_lpDDS->Unlock(NULL);
	m_lpDDXO[2].m_lpDDS->Unlock(NULL);
	screen.m_lpDDSBack->m_lpDDS->Unlock(NULL);
}
//******************************************************************************
void CHra::Done()
{
	t_kill = true;
	if (connected) {
		link.m_DP->Close();
		connected = FALSE;
	}

	AfxGetApp()->m_pMainWnd->SendMessage(WM_MENU,0,0);
}


void CHra::SendMess(st_message mess)
{
	if(!connected) return;
	byte buffer[5];
	buffer[0] = H_MESSAGE;
	buffer[1] = mess.message;
	buffer[2] = mess.type;
	buffer[3] = mess.x;
	buffer[4] = mess.y;
	CString s;
	s.Format("Message : %d\n",mess.message);
	TRACE(s);
	if(link.Send(player.m_ID, DPID_ALLPLAYERS, DPSEND_GUARANTEED, &buffer, sizeof(byte)*5) != DP_OK ){
		TRACE("ERROR IN SENDIG\n");
		buffer[4] = mess.y;
	}
}
