/*******************************************************************************/
//  Bernard Lidicky - 1999
//  CHra class - Include
/*******************************************************************************/
// definuje hraci prostredi

#if !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
#define AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// co je na plose
#define KRIZEK  0 // slouzi i jako m_tahne
#define KOLECKO 1 // slouzi i jako m_tahne
#define NIC     2 // prazdne policko
#define COKOLI  3 // slouzi pri urcovanitahu pocitace
#define KRAJ    4 // slouzi pro ohraniceni

// zobrazeni
#define X_TYPES    3
#define Y_TYPES    3
#define MAX_TYPES  6

/// maximalni mozne rozmery plochy
#define PLOCHAX 40
#define PLOCHAY 40

// kdo je co  m_tahne, m_hrac[2]
#define CLOVEK  0
#define MODUL1  1
#define MODUL2  2
#define MODUL3  3
#define MODUL5  4
#define MODUL6  5

#define MODUL4  6 // network modul

#define MODULS  5 // modulu (nepocitase network)
#define MODULSP 6 // modules + player

// Multi player
#define MUTLI_NO     0
#define MULTI_SEVER  1
#define MULTI_CLIENT 2

#define MESS_TEST  0
#define MESS_TAH   2
#define MESS_MYS   3
#define MESS_END   4

#define H_MESSAGE  77 // rozpoznavaci kod zpravy

typedef struct {
	byte  message;
	byte  type; // krizek / kolecko
	byte  x;   // kam tahnul X
	byte  y;   // kam tahnul Y
} st_message;

/***************************************/

class CHra : public Base 
{
public:
	void SendMess(st_message mess);
	void Done();
	void UnlockBuffers();
	void LockBuffers();
	void DalsiTah();
	void Activate(); // oznamuje, ze se hra stala aktivni
	CHra();          // konstruktor
	virtual ~CHra(); // destrukktor
	BOOL Draw();     // vykresli aktualinni stav do back surface
	int Hledej(CPoint pt,int p,int d, int t, int c, int s);  // hleda v hraci pose
	int Hledej_inline(CPoint pt,int l3,int l2, int l1, int p1, int p2, int p3);
	int Konec(); // vrati, zda nekdo vyhral
	void NovaHra(int pl1, int pl2, int plochax, int plochay, int zacina); // inicializuje novou hru
	void OnKeyDown(UINT nChar);       // uzivatel neco stiskl
	void OnLButtonDown(CPoint point); // zprava mysi
	void OnLButtonUp(CPoint point);   // zprava mysi
	void OnMouseMove(CPoint point);   // zprava mysi
	BOOL OnTimer();  // odezva hlavniho timeru ( 40 ms )
	void Restore();  // pri ztrate surfacu
	void Tahnul(CPoint kam); // kam tahnul nas hrac ?


	// bitmapy
	CDXSurface     m_lpDDAll;      // pozadi
	CDXSurface     m_lpDDLineH;      // horizontalni cara
	CDXSurface     m_lpDDLineV;      // vertikalni cara
	CDXSurface     m_lpDDXO[3];        // Krizek / Kolecko / Mys
	HBITMAP        m_lpDDXOA[MAX_TYPES];      // Alpha krizek / kolecko --- !! Musi byt 256 barev
	
	DDSURFACEDESC  m_lpDesDst;  // pro alpha blitting
	DDSURFACEDESC  m_lpDesSrc[3];
	DDSURFACEDESC  m_lpDesAlp[MAX_TYPES];


	CFont m_font;  // hlavni font
	CWinThread *m_thread; // drzime si ukazatel
	int   m_t1; // stratovni cas jednoho tahu

	int    m_toredraw;
	CPoint m_plr;  // kam se ma kreslit cerveny X / O  -  Urceno mysi hrace
 
	int m_plocha[PLOCHAX+10][PLOCHAY+10]; // hraci plocha
	int m_plochaD[PLOCHAX+10][PLOCHAY+10]; // zobrazovaci plocha - tady je to, co se zobrazuje
	CSize m_p;    // plocha ( rozmery )
	int m_tah;    // cilso tahu
	int m_tahne; // 1 , 2
	int m_hrac[2];  // kdo hraje
	int m_cas[2];    // jak dlouho
	int m_rand;
};

// jednoducha utilitka
void dxutil_InitStructure(DDSURFACEDESC& structure);

// threads communications
extern bool t_kill;
extern bool t_hotovo;
extern bool t_running;


#endif // !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
