/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  Modul1.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "piskII.h"
#include "hra.h"
#include "modul1.h"
/*
casova slozitost vypoctu se vypocita jako :
	
   M1_CNT_TEST na (M1_UZLU_TEST)  => exponencilani
	slusny cas na P-150Mhz je do 5000 (cca 20s )
*/
#define M1_UZLU_TEST  7   // urcuje hloubku zanoren
#define M1_CNT_MAX    500 // maximalne hleda 
#define M1_CNT_TEST   3   // maximalne testuje 



typedef struct {
	int    uzlu;
	int    natahu;
	int    body;  // body_t v abs hodnote
	int    body_t;
	int    ja;
	CPoint kam;
}  st_m1_uzel;


typedef struct {
	int  body;  // body_t v absolutni hodnote
	int  body_t;
	int  x;
	int  y;
} st_m1_bod;

st_m1_uzel m1_Test(st_m1_uzel test, CHra *h);  // testuje tahy
int m1_compare( const void *arg1, const void *arg2 ); // pro qsort


//******************************************************************************
// m1_t_Tahni
UINT m1_t_Tahni(LPVOID p_hra){
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHra *h = (CHra*) p_hra;
	if(h->Konec() != NIC) return 0;
	srand(h->m_rand);
	// myslici proces

	st_m1_uzel uzel;
	uzel.body = 0;
	uzel.kam.x = 0;
	uzel.kam.y = 0;
	uzel.uzlu = 0;
	uzel.ja = h->m_tahne;
	if(uzel.ja == KRIZEK) uzel.natahu = KOLECKO; // v testu dojde k prohozeni
	else uzel.natahu = KRIZEK;

	if (h->m_tah == 0) { // zpracovani 1. tahu
		uzel.kam.x = (h->m_p.cx/2) - 5 + Nahoda(10)+5;
		uzel.kam.y = (h->m_p.cy/2) - 5 + Nahoda(10)+5;
	}
	else uzel = m1_Test(uzel,h);

	// navrat
	if(!t_kill) h->Tahnul(uzel.kam);

	t_running = false;
	h->m_thread = NULL;
	return 0;
}

//******************************************************************************
// m1_compare
int m1_compare( const void *arg1, const void *arg2 ){
	st_m1_bod *a = (st_m1_bod*) arg1;
	st_m1_bod *b = (st_m1_bod*) arg2;
	if(a->body > b->body) return -1;
	else if(a->body == b->body) return 0;
			else return 1;
}

//******************************************************************************
// m1_Test
st_m1_uzel m1_Test(st_m1_uzel test, CHra *h) {
	
	if(t_kill) return test; // rychle konec - nekdo si to preje

	// priprava uzlu
	if(test.natahu == KRIZEK) test.natahu = KOLECKO;
	else test.natahu = KRIZEK;
	test.uzlu++;

	// je konec zanorovani ?
//	if (test.uzlu < M1_UZLU_TEST) {
		CPoint kam;
		int cnt;
		st_m1_bod body[M1_CNT_MAX];
		long k,ka,kt,m;
		CPoint po;

		int X = test.natahu;
		int O;
		if(X == KRIZEK) O = KOLECKO;
		else O = KRIZEK;
		int N = NIC;
		int C = COKOLI;
		
		// init pole
		cnt = 0; // v ploi je 0 prvku
		for (po.x = 5; po.x < h->m_p.cx+5; po.x++)
			for (po.y = 5; po.y < h->m_p.cy+5; po.y++) {
				if(h->m_plocha[po.x][po.y] != NIC) continue; // jemna opimalizace

				k = 0;  // pro jednu cast
				ka = 0; // absoutni hodnota
				kt = 0; // totalni - soucet 
				
				// vyhrane situace :
				k = 0;
				k += 1000000 * h->Hledej(po,X,X,X,X,C);
				k += 1000000 * h->Hledej_inline(po,C,X,X, X,X,C); 	
				k += 1000000 * h->Hledej_inline(po,X,X,X, X,C,C);
				if(k > 0) { // neni o cem dikutovat
					test.body = k;
					if(test.ja == O)
						test.body_t = -k;
					else test.body_t = k;
					test.kam = po;
					return test;
				}


				// temer smrt
				k = 0;
				k +=  80000 * h->Hledej(po,O,O,O,O,C);  //				*OOOO
				k +=  80000 * h->Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
				k +=  80000 * h->Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O
				kt -= k; 
				ka += k;

				// temer vyhrane :
				k = 0;
				k +=  60000 * h->Hledej_inline(po,N,X,X, X,N,C);  // _XX*X_
				if (((h->Hledej(po,X,X,X,N,C) > 0))&&(h->Hledej_inline(po,C,C,N, X,X,X)>0)) k += 60000; // _XXX*_
				if (h->Hledej_inline(po,C,C,N, X,X,N)>1) k += 60000; // _*XX_ && _*XX_
				if (k < 60000) {
					if (h->Hledej(po,X,X,X,N,C)&&h->Hledej_inline(po,C,C,N, X,X,X)) k += 60000; // *XXX_ && _*XXX
					if (h->Hledej(po,X,X,X,N,C) > 1)	k+= 60000;      //2* *XXX_ 
					if (h->Hledej_inline(po,C,C,N, X,X,X) > 1) k += 60000; //2*  _*XXX
					if (h->Hledej(po,X,X,X,N,C)||h->Hledej_inline(po,C,C,N, X,X,X))  // *XXX_ || _*XXX
						if(h->Hledej_inline(po,N,N,X, X,N,C) ||  // _X*X__		
						   h->Hledej_inline(po,C,C,N, X,X,N) ||  // _*XX_
						   h->Hledej_inline(po,C,C,N, N,X,X) ||  // _*_XX_
						  (h->Hledej(po,X,N,X,N,C)&&h->Hledej_inline(po,C,C,N, X,N,X))) k += 60000; // _*X_X_
				}
				kt += k;
				ka += k;

				// kriticke situace :
				k = 0;
				k +=  50000 * h->Hledej_inline(po,C,N,O, O,O,N);       //_O*OO_
				if (h->Hledej_inline(po,C,C,N, O,O,N)>1) k+= 40000; // _*OO_ && _*OO_
				if ((h->Hledej(po,O,O,O,N,C)>0)&&(h->Hledej_inline(po,C,C,N, O,O,O)>0)) k += 50000;	// 	_*OOO_
				else if (h->Hledej(po,O,O,O,C,C)>1) k += 40000;     //  *OOO && *OOO
						else if(h->Hledej(po,O,O,O,N,C)) k += 2000; // *OOO_
							else if(h->Hledej(po,O,O,O,C,C) && h->Hledej_inline(po,C,C,N, O,O,O)) k += 2000; // _*OOO
				if ((h->Hledej(po,O,O,O,C,C)>0)&&(h->Hledej(po,O,O,N,C,C)>0)) k += 30000; // *OOO && *OO_
				if (h->Hledej_inline(po,N,N,O, O,N,C) > 1) k+= 40000; //			O*O && _O*O__
				kt -= k;
				ka += k;
			
					// zajimave situace + pasti :
				if ( kt < 40000) {
					k = 0;
					if ((h->Hledej_inline(po,N,N,X, X,N,C)) > 1) k+= 20000; //				  X	
//																									_X*X__		
//																										  X	
					if ((h->Hledej(po,X,X,X,C,C)>0)&&(h->Hledej(po,X,X,N,C,C)>0)) k += 20000; // *XXX && *XX_					
					if ((h->Hledej_inline(po,C,C,N, X,X,N)>0)&&(h->Hledej_inline(po,C,C,N, N,X,X)>0)) k+= 30000; // _*XX_ &&   _*_XX
					if ((m =  30000 * h->Hledej(po,X,X,X,N,C)) > 0) k += m ;  // *XXX_
					else if ((m =  30000 * h->Hledej_inline(po,X,X,X, N,C,C)) > 0) k += m ;  // _*XXX
						else if(Nahoda(5) > 3) k +=  25000 * h->Hledej(po,X,X,X,C,C);  // *XXX
					k +=   8000 * h->Hledej_inline(po,N,X,X, X,C,C); // _XX*X 
					kt += k;
					ka += k;
					
					k = 0;
					if (m = h->Hledej_inline(po,N,N,O, O,N,N)) k += m * 3000; // __O*O__
					else k +=   3200 * h->Hledej_inline(po,C,N,O, O,N,C); //  _O*O_
					if ((m = h->Hledej(po,O,C,C,C,C)>3)) k+= 700; // trochu moc O
					if ((h->Hledej_inline(po,C,C,N, O,O,N)>0)&&(h->Hledej_inline(po,C,C,N, N,O,O)>0)) k+= 10000; // _*OO_ &&   _*_OO
					kt -= k;
					ka += k;
				}

			// standart :
				k = 0;
				if ((m = h->Hledej_inline(po,C,C,N, X,X,N))>0) k +=   1000 * m; // _*XX_
				else k +=    500 * h->Hledej(po,X,X,N,C,C);  // *XX_
				k +=    500 * h->Hledej(po,N,X,X,C,C);	// *_XX
				k +=    900 * h->Hledej(po,N,X,N,X,C);	// *_X_X
				k +=   1100 * h->Hledej_inline(po,C,N,X, X,N,C); // _X*X_
				k +=      5 * h->Hledej(po,X,C,C,C,C); // *X
				k +=    300 * h->Hledej(po,X,N,C,C,C); // *X_
				kt += k;
				ka += k;

				k = 0;
				k +=    500 * h->Hledej(po,O,O,N,C,C);	// *OO_
				k +=	  200 * h->Hledej(po,O,N,C,C,C); // *O_
				k +=      4 * h->Hledej(po,O,C,C,C,C); // *O
				kt -= k;
				ka += k;
			// zarazeni do moznosti
			if((cnt < M1_CNT_MAX) &&
				(ka > 0)) { 
				body[cnt].x = po.x;
				body[cnt].y = po.y;
				body[cnt].body = ka;
				body[cnt].body_t = kt;
				cnt++;
			}
			if(t_kill) return test; // killing thread;
		} // for (po.y = 5; po.y < h->m_p.cy+5; po.y++)
		qsort(&body,cnt,sizeof(st_m1_bod),m1_compare);
		if(cnt > M1_CNT_TEST) cnt = M1_CNT_TEST;

	if (test.uzlu < M1_UZLU_TEST) {
		// rekurze
		if(test.ja != test.natahu) test.body_t = 0xFFFFFFF;
		else test.body_t = -0xFFFFFFF;
		st_m1_uzel go = test;
		for(k = 0; k < cnt; k++){
			if(t_kill) return go; // killing thread;
			go = test;
			go.kam.x = body[k].x;
			go.kam.y = body[k].y;
			go.body  = body[k].body;
			go.body_t = body[k].body_t;
			// simulace tahu
			h->m_plocha[body[k].x][body[k].y] = test.natahu;
			go = m1_Test(go,h);
			// opravime hraci plochu zpet
			h->m_plocha[body[k].x][body[k].y] = NIC;
			// otestujeme, co sjme dostali
			if(test.ja != test.natahu) {
				if(test.body_t > go.body_t) {
					test.body_t = go.body_t;
					test.kam.x  = body[k].x;
					test.kam.y  = body[k].y;
				}
			}
			else 
				if(test.body_t < go.body_t) {
					test.body_t = go.body_t;
					test.kam.x  = body[k].x;
					test.kam.y  = body[k].y;
				}
			// aby se hry tolik neopakovaly
			if((test.body_t == go.body_t)&&(Nahoda(10) > 5)) {
				test.body_t = go.body_t;
				test.kam.x  = body[k].x;
				test.kam.y  = body[k].y;
			}
		}// for(k = 0; k < cnt; k++){
		if (test.body_t = -1000000){ // pri prohre zkusime dat nej moznost, treba to protihrace zmatne
			test.kam.x  = body[0].x;
			test.kam.y  = body[0].y;
		}

	} // if (test.uzlu < M1_UZLU_TEST) 
	else {
		if(test.ja != test.natahu)
			test.body_t = -body[0].body_t;
		else
			test.body_t = body[0].body_t;
		test.body   = body[0].body;
		test.kam.x  = body[0].x;
		test.kam.y  = body[0].y;
	}// jinak obodovani
	return test;
}