/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  Modul5.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "piskII.h"
#include "hra.h"
#include "modul5.h"
/*
	Jde o system z modulu 1 se zmenou bodovani tahu
	casova slozitost vypoctu se vypocita jako :
	
*/
#define M5_UZLU_TEST  3   // urcuje hloubku zanoreni
#define M5_CNT_MAX    500 // maximalne hleda 
#define M5_CNT_TEST   5   // maximalne testuje 

// interni
CHra *h;

typedef struct {
	int    uzlu;
	int    natahu;
	int    body;  // body_t v abs hodnote
	int    body_t;
	int    ja;
	CPoint kam;
}  st_m5_uzel;


typedef struct {
	int  body;  // body_t v absolutni hodnote
	int  body_t;
	int  x;
	int  y;
} st_m5_bod;

// vodovaci konstanty

st_m5_uzel m5_Test(st_m5_uzel test);  // testuje tahy
int m5_compare( const void *arg1, const void *arg2 ); // pro qsort

// tohle je inline
int m5_search(int tx, int ty, int kolik,int co);// vraci kolik nasel v rade, kolik = kolikatice hledat
// tohle taky
bool m5_search_way(int tx, int ty, int kolik,int co, int x, int y); // vraci zda existujr v danem smeru

//******************************************************************************
// m5_t_Tahni
UINT m5_t_Tahni(LPVOID p_hra){
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	h = (CHra*) p_hra;
	if(h->Konec() != NIC) return 0;
	srand(h->m_rand);
	// myslici proces

	st_m5_uzel uzel;
	uzel.body = 0;
	uzel.kam.x = 0;
	uzel.kam.y = 0;
	uzel.uzlu = 0;
	uzel.ja = h->m_tahne;
	if(uzel.ja == KRIZEK) uzel.natahu = KOLECKO; // v testu dojde k prohozeni
	else uzel.natahu = KRIZEK;

	if (h->m_tah == 0) { // zpracovani 1. tahu
		uzel.kam.x = (h->m_p.cx/2) - 5 + Nahoda(10)+5;
		uzel.kam.y = (h->m_p.cy/2) - 5 + Nahoda(10)+5;
	}
	else uzel = m5_Test(uzel);

	CString s;
	s.Format("celkem : x = %d, y = %d : ka = %d, kt = %d \n",uzel.kam.x,uzel.kam.y,uzel.body,uzel.body_t);
	TRACE(s);


	// navrat
	if(!t_kill) h->Tahnul(uzel.kam);

	t_running = false;
	h->m_thread = NULL;
	return 0;
}

//******************************************************************************
// m5_compare
int m5_compare( const void *arg1, const void *arg2 ){
	st_m5_bod *a = (st_m5_bod*) arg1;
	st_m5_bod *b = (st_m5_bod*) arg2;
	if(a->body > b->body) return -1;
	else if(a->body == b->body) return 0;
			else return 1;
}

//******************************************************************************
// m5_Test
st_m5_uzel m5_Test(st_m5_uzel test) {
	
	if(t_kill) return test; // rychle konec - nekdo si to preje

	// priprava uzlu
	if(test.natahu == KRIZEK) test.natahu = KOLECKO;
	else test.natahu = KRIZEK;
	test.uzlu++;

	CPoint kam;
	int cnt;
	st_m5_bod body[M5_CNT_MAX];
	long k,ka,kt;
	CPoint po;

	int X = test.natahu;
	int O;
	if(X == KRIZEK) O = KOLECKO;
	else O = KRIZEK;
	int N = NIC;
	int C = COKOLI;
	
	int Xtab[5];
	int Otab[5];

	//!!!!!! debug only
	CString s;

	// init pole
	// bodovaci cast
	cnt = 0; // v ploi je 0 prvku
	for (po.x = 5; po.x < h->m_p.cx+5; po.x++)
		for (po.y = 5; po.y < h->m_p.cy+5; po.y++) {
			if(h->m_plocha[po.x][po.y] != NIC) continue;


			// vyhrane situace - radsi spolehlivym algoritmem :-)
			k = 0;
			k += 1000000 * h->Hledej(po,X,X,X,X,C);
			k += 1000000 * h->Hledej_inline(po,C,X,X, X,X,C); 	
			k += 1000000 * h->Hledej_inline(po,X,X,X, X,C,C);
			if(k > 0) { // neni o cem dikutovat
				test.body = k;
				if(test.ja == O)
					test.body_t = -k;
				else test.body_t = k;
				test.kam = po;
				return test;
			}
			
			// prohledani pole

			Xtab[4] = m5_search(po.x,po.y,4,X);
			Xtab[3] = m5_search(po.x,po.y,3,X);
			Xtab[2] = m5_search(po.x,po.y,2,X);
			Xtab[1] = m5_search(po.x,po.y,1,X);

			Otab[4] = m5_search(po.x,po.y,4,O);
			Otab[3] = m5_search(po.x,po.y,3,O);
			Otab[2] = m5_search(po.x,po.y,2,O);
			Otab[1] = m5_search(po.x,po.y,1,O);

			// obodovani na zaklade tabulek
			k  = 0;
			// X table
			if(Xtab[4] > 1) k += 200000;
			if(Xtab[4])     k +=  90000;
			if(Xtab[3] > 1) k +=  40000;
			if(Xtab[3])     k +=  15000;
			if(Xtab[4] && Xtab[3]) k += 20000;
			if(Xtab[3] && Xtab[2]) k += 20000;
			if(Xtab[2] > 1) k +=  9000;
			if(Xtab[2])     k +=  2000;
			if(Xtab[1])     k +=   100;

			ka = kt = k;
			k = 0;
			// O table
			if(Otab[4] > 1) k += 150000;
			if(Otab[4])     k +=  80000;
			if(Otab[3] > 1) k +=  30000;
			if(Otab[3])     k +=  12000;
			if(Otab[4] && Otab[3]) k += 19000;
			if(Otab[3] && Otab[2]) k += 19000;
			if(Otab[2] > 1) k +=  5000;
			if(Otab[2])     k +=   900;
			if(Otab[1])     k +=    90;

			kt -= k;
			ka += k;

			if(kt != 0) {
				s.Format("x = %d, y = %d : ka = %d, kt = %d \n",po.x,po.y,ka,kt);
//				TRACE(s);
			}

			// zarazeni do moznosti
			if((cnt < M5_CNT_MAX) &&
				(ka > 0)) { 
				body[cnt].x = po.x;
				body[cnt].y = po.y;
				body[cnt].body = ka;
				body[cnt].body_t = kt;
				cnt++;
			}
			if(t_kill) return test; // killing thread;
		} // for (po.y = 5; po.y < h->m_p.cy+5; po.y++)

	// srovnani podle poctu bodu
	qsort(&body,cnt,sizeof(st_m5_bod),m5_compare);
	if(cnt > M5_CNT_TEST) cnt = M5_CNT_TEST;

	// rozdelovaci cast
	if (test.uzlu < M5_UZLU_TEST) {
		// rekurze
		if(test.ja != test.natahu) test.body_t = 0xFFFFFFF;
		else test.body_t = -0xFFFFFFF;
		st_m5_uzel go = test;
		for(k = 0; k < cnt; k++){
			if(t_kill) return go; // killing thread;
			go = test;
			go.kam.x = body[k].x;
			go.kam.y = body[k].y;
			go.body  = body[k].body;
			go.body_t = body[k].body_t;
			// simulace tahu
			h->m_plocha[body[k].x][body[k].y] = test.natahu;
			go = m5_Test(go);
			// opravime hraci plochu zpet
			h->m_plocha[body[k].x][body[k].y] = NIC;
			// otestujeme, co sjme dostali
			if(test.ja != test.natahu) {
				if(test.body_t > go.body_t) {
					test.body_t = go.body_t;
					test.kam.x  = body[k].x;
					test.kam.y  = body[k].y;
				}
			}
			else 
				if(test.body_t < go.body_t) {
					test.body_t = go.body_t;
					test.body   = go.body;
					test.kam.x  = body[k].x;
					test.kam.y  = body[k].y;
				}
			// aby se hry tolik neopakovaly
			if((test.body_t == go.body_t)&&(Nahoda(10) > 5)) {
				test.body_t = go.body_t;
				test.body   = go.body;
				test.kam.x  = body[k].x;
				test.kam.y  = body[k].y;
			}
		}// for(k = 0; k < cnt; k++){
		if (test.body_t = -1000000){ // pri prohre zkusime dat nej moznost, treba to protihrace zmatne
			test.kam.x  = body[0].x;
			test.kam.y  = body[0].y;
		}

	} // if (test.uzlu < M5_UZLU_TEST) 
	else {
		if(test.ja != test.natahu)
			test.body_t = -body[0].body_t;
		else
			test.body_t = body[0].body_t;
		test.body   = body[0].body;
		test.kam.x  = body[0].x;
		test.kam.y  = body[0].y;
	}// jinak obodovani

	s.Format("mezi : x = %d, y = %d : ka = %d, kt = %d \n",test.kam.x,test.kam.y,test.body,test.body_t);
	TRACE(s);

	return test;
}
//******************************************************************************
// m5_search
int m5_search(int tx, int ty, int kolik,int co){
	if(h->m_plocha[tx][ty] != NIC) return 0;
	int total = 0;
	if(m5_search_way(tx,ty,kolik,co, 1, 1)) total++;
	if(m5_search_way(tx,ty,kolik,co, 1, 0)) total++;
	if(m5_search_way(tx,ty,kolik,co, 1,-1)) total++;
	if(m5_search_way(tx,ty,kolik,co,-1, 1)) total++;
	if(m5_search_way(tx,ty,kolik,co,-1, 0)) total++;
	if(m5_search_way(tx,ty,kolik,co,-1,-1)) total++;
	if(m5_search_way(tx,ty,kolik,co, 0, 1)) total++;
	if(m5_search_way(tx,ty,kolik,co, 0,-1)) total++;
	return total;
}
//******************************************************************************
// m5_search_way
bool m5_search_way(int tx, int ty, int kolik,int co, int x, int y){
	
	int total = 0;
	bool lsp;
	int m = 0;

	int mx,my;

	lsp = false;
	int spc = 0;
	mx = tx + x;
	my = ty + y;
	while((spc < 3) && (((h->m_plocha[mx][my] == NIC)&&(!lsp))||(h->m_plocha[mx][my] == co))) {
		if(h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}
	if(!lsp) m++;

	spc = 0;
	mx = tx - x;
	my = ty - y;
	lsp = false;
	while((spc < 3) && (((h->m_plocha[mx][my] == NIC)&&(!lsp))||(h->m_plocha[mx][my] == co))) {
		if(h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}

	if((total == 4)&&((h->m_plocha[tx - x][ty - y] == NIC)&&((h->m_plocha[tx + x][ty + y] == NIC))))
		return false;

	if(!lsp) m++;
	if(total < 2) total -= m;

	if (total == kolik) return true;
	return false;
}
