/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  Modul6.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "piskII.h"
#include "hra.h"
#include "modul6.h"
/*
	Jde o system z modulu 1 se zmenou bodovani tahu
	casova slozitost vypoctu se vypocita jako :
	
*/
#define M6_CNT_MAX    500 // maximalne hleda 

// interni
CHra *m6_h;

typedef struct {
	int  body;  // body_t v absolutni hodnote
	int  x;
	int  y;
} st_m6_bod;

// tohle je inline
int m6_search(int tx, int ty, int kolik,int co);// vraci kolik nasel v rade, kolik = kolikatice hledat
inline bool m6_search_way(int tx, int ty, int kolik,int co, int x, int y); // vraci zda existujr v danem smeru

// s mezerou
int m6_msearch(int tx, int ty, int kolik,int co);// vraci kolik nasel v rade, kolik = kolikatice hledat
inline bool m6_msearch_way(int tx, int ty, int kolik,int co, int x, int y); // vraci zda existujr v danem smeru


//******************************************************************************
// m6_t_Tahni
UINT m6_t_Tahni(LPVOID p_hra){
	int i;
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	m6_h = (CHra*) p_hra;
	if(m6_h->Konec() != NIC) return 0;

	//!!!!!! debug only
	CString s;

		int cnt;
		st_m6_bod max;
		max.body = -1;
		max.x = 5;
		max.y = 5;
		long k;
		CPoint po;

		int X = m6_h->m_tahne;
		int O;
		if(X == KRIZEK) O = KOLECKO;
		else O = KRIZEK;
		int N = NIC;
		int C = COKOLI;
	
		int Xtab[5];
		int Otab[5];

		int Xmtab[5]; // tabulky s mezerou
		int Omtab[5]; // n a zacatku, nebo na konci

	srand(m6_h->m_rand);
	// myslici proces

	if (m6_h->m_tah == 0) { // zpracovani 1. tahu
		max.x = (m6_h->m_p.cx/2) - 5 + Nahoda(10)+5;
		max.y = (m6_h->m_p.cy/2) - 5 + Nahoda(10)+5;
	}
	else {

		// init pole
		// bodovaci cast
		cnt = 0; // v ploi je 0 prvku
		for (po.x = 5; po.x < m6_h->m_p.cx+5; po.x++)
			for (po.y = 5; po.y < m6_h->m_p.cy+5; po.y++) {
				if(m6_h->m_plocha[po.x][po.y] != NIC) continue;


				// vyhrane situace - radsi spolehlivym algoritmem :-)
				k = 0;
				k += 1000000 * m6_h->Hledej(po,X,X,X,X,C);
				k += 1000000 * m6_h->Hledej_inline(po,C,X,X, X,X,C); 	
				k += 1000000 * m6_h->Hledej_inline(po,X,X,X, X,C,C);
				if(k > 0) { // neni o cem dikutovat
					m6_h->Tahnul(po);
					t_running = false;
					return 0;
				}
			
				// plneni tabulek 
				for(i = 1; i < 5; i++){
					Xtab[i] = m6_search(po.x,po.y,i,X);
					Otab[i] = m6_search(po.x,po.y,i,O);
				   Xmtab[i] = m6_msearch(po.x,po.y,i,X); // tabulky s mezerou
					Omtab[i] = m6_msearch(po.x,po.y,i,O); // n a zacatku, nebo na konci
				}

				// obodovani na zaklade tabulek
				// X tables
				k = 0;
				if(Xtab[4] > 1) k += 200000;
				else 
					if(Xtab[4])     k +=  90000;
				if(Xtab[3] > 1) k +=  40000;
				else 
					if(Xtab[3])     k +=  15000;
				if(Xtab[4] && Xtab[3]) k += 20000;
				if(Xtab[3] && Xtab[2]) k += 20000;
				if(Xtab[2] > 1) k +=  9000;
				else 
					if(Xtab[2])     k +=  2000;
				if(Xtab[1])     k +=   100;

				// O tables
				if(Otab[4] > 1) k += 150000;
				else if(Otab[4])     k +=  80000;
				if(Otab[3] > 1) k +=  30000;
				else 
					if(Otab[3])     k +=  29000;
				if(Otab[4] && Otab[3]) k += 19000;
				if(Otab[3] && Otab[2]) k += 19000;
				if(Otab[2] > 1) k +=  5000;
				else if(Otab[2])     k +=   900;
				if(Otab[1])     k +=    90;


				if(k != 0) {
					s.Format("x = %d, y = %d : body = %d \n",po.x,po.y,k);
					TRACE(s);
				}

				if(k > max.body) {
					max.x = po.x;
					max.y = po.y;
					max.body = k;
				}
				else 
					if ((k == max.body) && (Nahoda(5) == 1)){
						max.x = po.x;
						max.y = po.y;
						max.body = k;
					}

				if(t_kill) return 0; // killing thread;
			} // for (po.y = 5; po.y < h->m_p.cy+5; po.y++)
	}


	s.Format("celkem : x = %d, y = %d : body = %d\n",max.x,max.y,max.body);
	TRACE(s);


	// navrat
	if(!t_kill) m6_h->Tahnul(CPoint(max.x,max.y));

	t_running = false;
	m6_h->m_thread = NULL;
	return 0;
}

//******************************************************************************
// m6_search
int m6_search(int tx, int ty, int kolik,int co){
	if(m6_h->m_plocha[tx][ty] != NIC) return 0;
	int total = 0;
	if(m6_search_way(tx,ty,kolik,co, 1, 1)) total++;
	if(m6_search_way(tx,ty,kolik,co, 1, 0)) total++;
	if(m6_search_way(tx,ty,kolik,co, 1,-1)) total++;
	if(m6_search_way(tx,ty,kolik,co,-1, 1)) total++;
	if(m6_search_way(tx,ty,kolik,co,-1, 0)) total++;
	if(m6_search_way(tx,ty,kolik,co,-1,-1)) total++;
	if(m6_search_way(tx,ty,kolik,co, 0, 1)) total++;
	if(m6_search_way(tx,ty,kolik,co, 0,-1)) total++;
	return total;
}
//******************************************************************************
// m6_search_way
inline bool m6_search_way(int tx, int ty, int kolik,int co, int x, int y){

	if((m6_h->m_plocha[tx+x][ty+y] == NIC) && (m6_h->m_plocha[tx-x][ty-y] == NIC)) return 0;
	
	int total = 0;
	bool lsp;
	int m = 0;

	int mx,my;

	lsp = false;
	int spc = 0;
	mx = tx + x;
	my = ty + y;
	while((spc < 3) && (((m6_h->m_plocha[mx][my] == NIC)&&(!lsp))||(m6_h->m_plocha[mx][my] == co))) {
		if(m6_h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}
	if(!lsp) m++;

	spc = 0;
	mx = tx - x;
	my = ty - y;
	lsp = false;
	while((spc < 3) && (((m6_h->m_plocha[mx][my] == NIC)&&(!lsp))||(m6_h->m_plocha[mx][my] == co))) {
		if(m6_h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}

	if((total == 4)&&((m6_h->m_plocha[tx - x][ty - y] == NIC)&&((m6_h->m_plocha[tx + x][ty + y] == NIC))))
		return false;

	if(!lsp) m++;
	if(total < 3) total -= m;

	if (total == kolik) return true;
	return false;
}
//******************************************************************************
// m6_msearch
int m6_msearch(int tx, int ty, int kolik,int co){
	if(m6_h->m_plocha[tx][ty] != NIC) return 0;
	int total = 0;
	if(m6_msearch_way(tx,ty,kolik,co, 1, 1)) total++;
	if(m6_msearch_way(tx,ty,kolik,co, 1, 0)) total++;
	if(m6_msearch_way(tx,ty,kolik,co, 1,-1)) total++;
	if(m6_msearch_way(tx,ty,kolik,co,-1, 1)) total++;
	if(m6_msearch_way(tx,ty,kolik,co,-1, 0)) total++;
	if(m6_msearch_way(tx,ty,kolik,co,-1,-1)) total++;
	if(m6_msearch_way(tx,ty,kolik,co, 0, 1)) total++;
	if(m6_msearch_way(tx,ty,kolik,co, 0,-1)) total++;
	return total;
}
//******************************************************************************
// m6_msearch_way
inline bool m6_msearch_way(int tx, int ty, int kolik,int co, int x, int y){

	if((m6_h->m_plocha[tx+x][ty+y] != NIC) && (m6_h->m_plocha[tx-x][ty-y] != NIC)) return 0;
//	if((m6_h->m_plocha[tx+x][ty+y] != NIC) && (m6_h->m_plocha[tx-x][ty-y] != NIC)) return 0;

	int total = 0;
	bool lsp;
	int m = 0;

	int mx,my;

	lsp = false;
	int spc = 0;
	mx = tx + x;
	my = ty + y;
	while((spc < 3) && (((m6_h->m_plocha[mx][my] == NIC)&&(!lsp))||(m6_h->m_plocha[mx][my] == co))) {
		if(m6_h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}
	if(!lsp) m++;

	spc = 0;
	mx = tx - x;
	my = ty - y;
	lsp = false;
	while((spc < 3) && (((m6_h->m_plocha[mx][my] == NIC)&&(!lsp))||(m6_h->m_plocha[mx][my] == co))) {
		if(m6_h->m_plocha[mx][my] == co) {
			total++;
			lsp = false;
		}
		else {
			spc++;
			lsp = true;
		}
		mx += x;
		my += y;
	}

	if(!lsp) m++;
	if(total < 3) total -= m;

	if (total == kolik) return true;
	return false;
}
